| C prototype: void SpriteX8_MIRROR_V_R(register short h asm("%d0"),register unsigned char* src asm("%a1"),register short bytewidth asm("%d2"),register unsigned char* dest asm("%a0")) __attribute__((__regparm__(4)));
|
| This routine is about 30% faster than the previous C routine.

.data
.globl SpriteX8_MIRROR_V_R
.even

SpriteX8_MIRROR_V_R:
    dbf      %d0,__Rest_of_SpriteX8_MIRROR_V_R
    rts

__Rest_of_SpriteX8_MIRROR_V_R:
    move.w   %d0,%d1

    move.w   %d3,-(%sp)

    move.w   %d2,%d3
    beq.s    __end_SpriteX8_MIRROR_V_R
    add.w    %d3,%d3

    mulu.w   %d2,%d1
    
    adda.w   %d1,%a0

    subq.w   #1,%d2

_beginning_of_loop_SpriteX8_MIRROR_V_R:
    move.w   %d2,%d1
_loop_SpriteX8_MIRROR_V_R:
| Very tight loop...
    move.b   (%a1)+,(%a0)+
    dbf      %d1,_loop_SpriteX8_MIRROR_V_R
    suba.w   %d3,%a0
    dbf      %d0,_beginning_of_loop_SpriteX8_MIRROR_V_R

__end_SpriteX8_MIRROR_V_R:
    move.w   (%sp)+,%d3
    rts
