| C prototype: void SlowFillRect_R(register unsigned char *plane asm("%a0"), register short x1 asm("%d0"), register short y asm("%d1"), register short x2 asm("%d2"), register short y2 asm("%d3"), short mode) __attribute__((__stkparm__));

| Input: a0    = plane.
|        d0    = x1.
|        d1    = y1.
|        d2    = x2.
|        d3    = y2.
|        4(sp) = mode.

| TODO: rewrite everything because it is currently too slow (write only one
| byte at once, do not draw columns). I may still have very old versions of
| FastFillRect on my HD, they should do a part of the job.

/*
.data
.xdef SlowFillRect_R
SlowFillRect_R:
    movem.l  %d3-%d5/%a2,-(%sp)
 
    move.l   %a0,%a1
    
    cmp.w    %d1,%d3
    bge.s    __continue_SFR_R__
 
    exg      %d1,%d3

__continue_SFR_R__:
    sub.w    %d1,%d3
 | d3.w = dy

    cmp.w    %d0,%d2
    bge.s    __calc_start_addr_SFR_R__
    exg      %d0,%d2

__calc_start_addr_SFR_R__:
    move.w   %d1,%d4
    lsl.w    #4,%d1
    sub.w    %d4,%d1
    add.w    %d1,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1
 
    move.w   %d0,%d4
    lsr.w    #3,%d4
    adda.w   %d4,%a0
| a0.l =address of the top left corner of the rectangle.
 
    move.w   %d2,%d4
    lsr.w    #3,%d4
    adda.w   %d4,%a1
| a1.l = address of the top right corner of the rectangle.
 
    move.w   %d2,%d1
    sub.w    %d0,%d1
| d1.w = dx
 
    not.w    %d0
    not.w    %d2

    moveq    #7,%d4
    and.w    %d4,%d0
    and.w    %d4,%d2

| d0.w = bit number of leftmost pixels.
| d2.w = bit number of rightmost pixels.
 
| Set up self-modifying code, optimized way.
    move.w   4+28(%sp),%d5
    moveq    #-0x70,%d4
    beq.s    __first_patch_SFR_R__
    subq.w   #2,%d5
    bne.s    __normal_SFR_R__
    moveq    #0x50,%d4
    bra.s    __first_patch_SFR_R__
__normal_SFR_R__:
    moveq    #-0x30,%d4
 
__first_patch_SFR_R__:
    lea      __patch_SFR_R__(%pc),%a2
    move.b   %d4,(%a2)
    move.b   %d4,__patch3_SFR_R__-__patch_SFR_R__(%a2)
    addi.b   #0x20,%d4
    move.b   %d4,__patch2_SFR_R__-__patch_SFR_R__(%a2)
 
| Check if dx is even.
    btst     #0,%d1
    bne.s    __no_middle_pixel_SFR_R__
    moveq   #__single_pixel_SFR_R__-__final_branch_SFR_R__-2,%d4
    bra.s    __second_patch_SFR_R__
__no_middle_pixel_SFR_R__:
    moveq   #__end_SFR_R__-__final_branch_SFR_R__-2,%d4
 
__second_patch_SFR_R__:
    move.b   %d4,__final_branch_SFR_R__-__patch_SFR_R__+1(%a2)
 
    lsr.w    #1,%d1
| The outer loop below will be executed (d1.w + 1) times. [CHECK]
 
    move.w   %d3,%d4            | save dy.
 
    suba.l   %a0,%a1
| a1.l = pointer difference between a0 and a1. Using that difference with
| d(an,ix) mode + only one lea 30(a0),a0 is faster and smaller than using
| (an) mode twice and two lea.
 
    moveq    #7,%d5
| Optimize the loop below.

    move.l   %a0,%a2
__outer_loop1_SFR_R__:
    move.w   %d4,%d3            | restore dy.
    move.l   %a2,%a0
 
__inner_loop1_SFR_R__:
    .byte    0x01               | one of bchg/bclr/bset %d0,(%a0)
__patch_SFR_R__:
    .byte    0xD0               | Any of 0x50, 0x90, 0xD0 is suitable.
 
    .byte    0x05               | one of bchg/bclr/bset %d2,0(%a0,%a1.w)
__patch2_SFR_R__:
    .byte    0xF0               | Any of 0x70, 0xB0, 0xF0 is suitable.
    .word    0x9000
 
    lea      30(%a0),%a0
    dbf      %d3,__inner_loop1_SFR_R__
    tst.w    %d1
__final_branch_SFR_R__:
    .byte    0x67 | opcode of beq.s
    .byte    0xFE
    subq.w   #1,%d0
    bge.s    __no_change_a0_SFR_R__
    move.w   %d5,%d0
    addq.l   #1,%a2
    subq.l   #1,%a1
 
__no_change_a0_SFR_R__:
    addq.w   #1,%d2
    cmp.w    %d2,%d5
    bge.s __no_change_a1_SFR_R__
    moveq    #0,%d2
    subq.l   #1,%a1
 
__no_change_a1_SFR_R__:
    dbf      %d1,__outer_loop1_SFR_R__

__single_pixel_SFR_R__:
__loop2_SFR_R__:
    lea      -30(%a0),%a0
    .byte    0x01               | one of bchg/bclr/bset %d0,(%a0)
__patch3_SFR_R__:
    .byte    0xD0               | Any of 0x50, 0x90, 0xD0 is suitable.
 
    dbf      %d4,__loop2_SFR_R__
     
__end_SFR_R__:
    movem.l  (%sp)+,%d3-%d5/%a2
    rts
*/
/*
| Notes in my native language, that's easier for me...
|
| NOTE: NE PAS SUPPRIMER, a va servir pour FastOutlinedRect(_R).
| Si on veut remplir un rectangle, y dans le bon ordre -> calculer start
| (1a) et dy (1d); abs(x2-x1) (1d);  numro de bit correspondant au pixel
| le plus  gauche (1d).

| Si on ne veut dessiner que les cts, c'est plus compliqu...
| Adresse et numro de bit du pixel  gauche (1a, 1d).
| Adresse du pixel en bas  gauche (1a).
| Sauvegarde de l'adresse du coin en bas  gauche (1a).
| Diffrence entre les adresses des cts verticaux (1d ou 1a). Il est moins
| coteux en temps (pas de diffrence en taille) de faire un lea -30(an),an
| + deux bxxx dn,(an) et bxxx dn,0(an,ix.w) que de faire deux lea -30(an),an
| et deux bxxx dn(an).
| On pourrait aussi faire du code auto-modifiant et utiliser du d(an). Mais
| a va tre sensiblement plus gros...

| 1d pour le numro de bit courant.
| 1d pour dy.
| 1d pour dx.
| Note: dy et dx pourraient tre regroups dans les deux words du mme
| registre (swap), ainsi que la sauvegarde du numro du bit  gauche et le
| bit courant. On n'a en effet pas besoin de ces donnes en mme temps.

| 3 ou 4 a, 4 ou 5 d.

| On dessine de la faon suivante:

| - - -> - -

|     et

| - - -> - -

|puis:

|        |

| ^        ^
|        |

|        |
*/
