| C prototype: void GrayClipSprite8_XOR_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned char *sprt0,unsigned char *sprt1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));

.data
.globl GrayClipSprite8_XOR_R
.even

__Pre_loop_GrayClipSprite8_XOR_R_2:
    lea      30(%a0),%a0
    lea      30(%a1),%a1
__Loop_GrayClipSprite8_XOR_R_2:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
    lsl.w    %d1,%d0
    eor.w     %d0,(%a0)

    moveq    #0,%d0
    move.b   (%a3)+,%d0
    lsl.w    %d1,%d0
    eor.w    %d0,(%a1)

    dbf      %d2,__Pre_loop_GrayClipSprite8_XOR_R_2

    movem.l  (%sp)+,%d3/%a2-%a3
    rts

GrayClipSprite8_XOR_R:
    movem.l  %d3/%a2-%a3,-(%sp)

    move.l   4+12(%sp),%a2
    move.l   4+12+4(%sp),%a3

    subq.w   #1,%d2		| %d2 = h - 1
    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite8_XOR_R	| h > 0 ?

    add.w    %d1,%d2		| %d2 = h + y
    bmi.s    __End_GrayClipSprite8_XOR_R		| y + h < 0 ?

    suba.w   %d1,%a2		| sprt0 -= y
    suba.w   %d1,%a3		| sprt1 -= y
    moveq.l  #0,%d1		| offsety = 0
    bra.s    __ClipX_GrayClipSprite8_XOR_R

__YPositive_GrayClipSprite8_XOR_R:
    subi.w   #127,%d3		| %d3 = y - 128
    bhi.s    __End_GrayClipSprite8_XOR_R		| y - 128 > 0 ?
    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite8_XOR_R	| h + y - 128 < 0 ?
    sub.w    %d3,%d2		| h -= h + y -128 (h = y - 128)

__CalcOffset_GrayClipSprite8_XOR_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15

__ClipX_GrayClipSprite8_XOR_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite8_XOR_R	| x < 0 ?
    cmpi.w   #239-8,%d0
    bhi.s    __ClipXRight_GrayClipSprite8_XOR_R	| x > 239-8

    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    and.w    #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bge.s    __Loop_GrayClipSprite8_XOR_R_2

    neg.w    %d1
__Loop_GrayClipSprite8_XOR_R_1:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
    swap.w   %d0
    lsr.l    %d1,%d0
    eor.l     %d0,(%a0)

    moveq.l  #0,%d0
    move.b   (%a3)+,%d0
    swap.w   %d0
    lsr.l    %d1,%d0
    eor.l     %d0,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite8_XOR_R_1
__End_GrayClipSprite8_XOR_R:
    movem.l  (%sp)+,%d3/%a2-%a3
    rts

__ClipXLeft_GrayClipSprite8_XOR_R:
    cmpi.w   #-8,%d0
    bls.s    __End_GrayClipSprite8_XOR_R		| x <= -8 ?

    neg.w    %d0		| shift = -x
    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

__LoopClipL_GrayClipSprite8_XOR_R:
    move.b   (%a2)+,%d1
    lsl.b    %d0,%d1		| shifting
    eor.b     %d1,(%a0)

    move.b   (%a3)+,%d1
    lsl.b    %d0,%d1		| shifting
    eor.b     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopClipL_GrayClipSprite8_XOR_R

    movem.l  (%sp)+,%d3/%a2-%a3
    rts

__ClipXRight_GrayClipSprite8_XOR_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite8_XOR_R		| x > 239

    andi.w   #7,%d0		| shiftx = x & 7
    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #29,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1
__LoopClipR_GrayClipSprite8_XOR_R:
    move.b   (%a2)+,%d1
    lsr.b    %d0,%d1
    eor.b     %d1,(%a0)

    move.b   (%a3)+,%d1
    lsr.b    %d0,%d1
    eor.b     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopClipR_GrayClipSprite8_XOR_R

    movem.l  (%sp)+,%d3/%a2-%a3
    rts
