| C prototype: void SpriteX8_OR_R(register short x asm("%d0"), register short y asm("%d1"),register short h asm("%d2"),register short w asm("%d3"),register unsigned char *sprt asm("%a1"),register void *dest asm("%a0")) __attribute__((__regparm__));

.data
.globl SpriteX8_OR_R
.even 

SpriteX8_OR_R:

	movem.l	%d3-%d5/%a2,-(%sp)

	move.w	%d1,%d4			| d4=d1
	lsl.w	#4,%d1			| d1*16
	sub.w	%d4,%d1			| d1=15y
 
	move.w	%d0,%d4	    		| d4=d0
	andi.w	#15,%d4			| d4=x%16

	lsr.w	#4,%d0			| d0/16
	add.w	%d1,%d0			| d0=15y+x/16
	add.w	%d0,%d0			| d0=30y+x/8 (even)
	
	adda.w	%d0,%a0			| align to the screen
 
 	moveq.l	#16,%d5	
 	sub.w	%d4,%d5			| d5=16-d4

	move.w	%d5,%d1
	addq.w	#8,%d1
	
 	subq.w	#1,%d2			| h-1
	subq.w	#1,%d3			| w-1
	

_EvenLoop_X8OR:	| beginning of the line if the adress is even
 	movea.l	%a0,%a2
 	move.w	%d3,%d4			| width
 	
_EvenLineLoop_X8OR:
 	
 	moveq.l	#0,%d0			| clear d0
 	move.w	(%a1)+,%d0		| get first byte
	dbf	%d4,_EvenLineLoopNotLastByte_X8OR	| goto the other semi-loop if that one's not the last byte on the line

	clr.b	%d0			| clear the remaining byte (not wanted)
	lsl.l	%d5,%d0
	or.l	%d0,(%a2)		| no need to increment (last byte)
	subq.l	#1,%a1			| re-align src
	adda.l	#30,%a0
	dbf	%d2,_OddLoop_X8OR	| next byte will at an odd adress	

	movem.l	(%sp)+,%d3-%d5/%a2

 	rts
 
_EvenLineLoopNotLastByte_X8OR:	| if it's not the last byte we can draw two in a row
 	lsl.l	%d5,%d0			| shift
 	or.l	%d0,(%a2)		| print a word and increment
 	addq.l	#2,%a2
	dbf	%d4,_EvenLineLoop_X8OR	| next line if some remain

	lea.l	30(%a0),%a0
	dbf	%d2,_EvenLoop_X8OR

	movem.l	(%sp)+,%d3-%d5/%a2
		
	rts

_OddLoop_X8OR:	| beginning of line if odd adress
 	movea.l	%a0,%a2
	move.w	%d3,%d4

_OddLineLoop_X8OR:
	moveq.l	#0,%d0
	move.b	(%a1)+,%d0		| first odd byte	
	dbf	%d4,_OddLineLoopNotLastByte_X8OR	| goto if it is not the last one
	
	lsl.l	%d1,%d0
	or.l	%d0,(%a2)
	lea.l	30(%a0),%a0
	dbf	%d2,_EvenLoop_X8OR

	movem.l	(%sp)+,%d3-%d5/%a2
		
	rts
	
_OddLineLoopNotLastByte_X8OR:
	lsl.w	#8,%d0
	move.b	(%a1)+,%d0		| second byte
	lsl.l	%d5,%d0
	or.l	%d0,(%a2)
	addq.l	#2,%a2
	dbf	%d4,_OddLineLoop_X8OR
	
	lea.l	30(%a0),%a0
	dbf	%d2,_OddLoop_X8OR

	movem.l	(%sp)+,%d3-%d5/%a2
	
	rts
