| C prototype: void GrayClipSprite32_MASK_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *sprt0,unsigned long *sprt1,unsigned long *mask0,unsigned long *mask1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));

.data
.globl GrayClipSprite32_MASK_R
.even

__GrayClipXRight_GrayClipSprite32_MASK_R:
    cmpi.w   #239,%d0
    bhi.s    __End2_GrayClipSprite32_MASK_R		| x > 239
    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #26,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1

    move.w   %d0,%d3
    andi.w   #15,%d0		| shiftx
    cmpi.w   #224,%d3
    blt.s    __Pre_LoopGrayClipR_GrayClipSprite32_MASK_R
    addi.w   #16,%d0
| Note: shift count can be large, therefore the shifting may be quite slow...
__Pre_LoopGrayClipR_GrayClipSprite32_MASK_R:
    moveq.l  #-1,%d3
    lsr.l    %d0,%d3
    not.l    %d3
__LoopGrayClipR_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d1
    lsr.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a0)

    move.l   (%a5)+,%d1
    lsr.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a1)

    move.l   (%a2)+,%d1
    lsr.l    %d0,%d1
    or.l     %d1,(%a0)

    move.l   (%a3)+,%d1
    lsr.l    %d0,%d1
    or.l     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipR_GrayClipSprite32_MASK_R
__End2_GrayClipSprite32_MASK_R:
    movem.l  (%sp)+,%d3/%a2-%a5
    rts

GrayClipSprite32_MASK_R:
    movem.l  %d3/%a2-%a5,-(%sp)

    lea.l    4+20(%sp),%a5
    movea.l  (%a5)+,%a2
    movea.l  (%a5)+,%a3
    movea.l  (%a5)+,%a4
    movea.l  (%a5),%a5

|    move.l   4+20(%sp),%a2
|    move.l   4+20+4(%sp),%a3
|    move.l   4+20+4+4(%sp),%a4
|    move.l   4+20+4+4+4(%sp),%a5

    subq.w   #1,%d2		| %d2 = h - 1
    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite32_MASK_R	| h > 0 ?
    add.w    %d1,%d2		| %d2 = y + h
    bmi.s    __End2_GrayClipSprite32_MASK_R		| y + h < 0 ?
    add.w    %d1,%d1		| %d1 = 2y
    add.w    %d1,%d1		| %d1 = 4y
    suba.w   %d1,%a2		| sprt -= 4y
    suba.w   %d1,%a3
    suba.w   %d1,%a4
    suba.w   %d1,%a5
    moveq.l  #0,%d1		| offsety = 0
    bra.s    __GrayClipX_GrayClipSprite32_MASK_R
__YPositive_GrayClipSprite32_MASK_R:
    subi.w   #127,%d3		| %d3 = y - 128
    bhi.s    __End_GrayClipSprite32_MASK_R		| y - 128 > 0 ?
    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite32_MASK_R	| h + y - 128 < 0 ?
    sub.w    %d3,%d2		| h -= h + y - 128
__CalcOffset_GrayClipSprite32_MASK_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15
__GrayClipX_GrayClipSprite32_MASK_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __GrayClipXLeft_GrayClipSprite32_MASK_R	| x < 0 ?
    cmpi.w   #239-32,%d0
    bhi.w    __GrayClipXRight_GrayClipSprite32_MASK_R	| x > 239-32
    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1
    moveq.l  #16,%d1
    andi.w   #15,%d0		| %d0 = righshift
    sub.w    %d0,%d1		| %d1 = 16 - (x & 15)
    move.w   %d4,-(%sp)
    move.w   %d5,-(%sp)

    moveq.l  #-1,%d3
    lsl.l    %d1,%d3
    move.l   %d3,%d4
    not.l    %d4
__Loop_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    or.w     %d3,%d5
    and.w    %d5,(%a0)+
    or.l     %d4,%d0
    and.l    %d0,(%a0)

    move.l   (%a5)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    or.w     %d3,%d5
    and.w    %d5,(%a1)+
    or.l     %d4,%d0
    and.l    %d0,(%a1)

    move.l   (%a2)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    and.l    %d3,%d0
    or.l     %d0,(%a0)
    and.w    %d4,%d5
    or.w     %d5,-(%a0)

    move.l   (%a3)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    and.l    %d3,%d0
    or.l     %d0,(%a1)
    and.w    %d4,%d5
    or.w     %d5,-(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite32_MASK_R
    move.w   (%sp)+,%d5
    move.w   (%sp)+,%d4
__End_GrayClipSprite32_MASK_R:
    movem.l  (%sp)+,%d3/%a2-%a5
    rts

__GrayClipXLeft_GrayClipSprite32_MASK_R:
    cmpi.w   #-32,%d0
    bls.s    __End_GrayClipSprite32_MASK_R		| x <= -32 ?
| Note: shift count can be large, therefore the shifting may be quite slow...
    neg.w    %d0		| shift = -x
    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    moveq.l  #-1,%d3
    lsl.l    %d0,%d3
    not.l    %d3
__LoopGrayClipL_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d1
    lsl.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a0)

    move.l   (%a5)+,%d1
    lsl.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a1)

    move.l   (%a2)+,%d1
    lsl.l    %d0,%d1		| shifting
    or.l     %d1,(%a0)

    move.l   (%a3)+,%d1
    lsl.l    %d0,%d1		| shifting
    or.l     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipL_GrayClipSprite32_MASK_R

    movem.l  (%sp)+,%d3/%a2-%a5
    rts
