| C prototype: void SpriteX8_BLIT(short x,short y,short h,unsigned char *sprt,unsigned char *maskval,short bytewidth,void *dest) __attribute__((__stkparm__));
| see SpriteX8_OR_R for comments

.data
.globl SpriteX8_BLIT
.even 

SpriteX8_BLIT:

	move.w	%d3,-(%sp)
	move.w	%d4,-(%sp)
	movem.l	%d5-%d6/%a2-%a4,-(%sp)
	
	move.l	24+20(%sp),%a0
	move.w	24+18(%sp),%d3
	move.l	24+14(%sp),%a2
	move.l	24+10(%sp),%a1
	move.w	24+8(%sp),%d2
	move.w	24+6(%sp),%d1
	move.w	24+4(%sp),%d0

	move.w	%d1,%d4		
	lsl.w	#4,%d1	
	sub.w	%d4,%d1
 
	move.w	%d0,%d4	   
	andi.w	#15,%d4	

	lsr.w	#4,%d0	
	add.w	%d1,%d0	
	add.w	%d0,%d0	
	
	adda.w	%d0,%a0	
 
 	moveq.l	#16,%d5	
 	sub.w	%d4,%d5	

	move.w	%d5,%d1
	addq.w	#8,%d1
	
 	subq.w	#1,%d2	
	subq.w	#1,%d3

_EvenLoop_X8B:	
 	movea.l	%a0,%a3
 	move.w	%d3,%d4	
	movea.l	%a2,%a4
	 	
_EvenLineLoop_X8B:
 	
 	moveq.l	#0,%d0	
 	moveq.l	#-1,%d6
 	move.w	(%a1)+,%d0
 	move.w	(%a4)+,%d6
	dbf	%d4,_EvenLineLoopNotLastByte_X8B

	clr.b	%d0
	st.b	%d6
	lsl.l	%d5,%d0
	rol.l	%d5,%d6

	and.l	%d6,(%a3)
	or.l	%d0,(%a3)
	
	subq.l	#1,%a1
	subq.l	#1,%a4
	
	adda.l	#30,%a0
	dbf	%d2,_OddLoop_X8B

	movem.l	(%sp)+,%d5-%d6/%a2-%a4
	move.w	(%sp)+,%d4
	move.w	(%sp)+,%d3

 	rts
 
_EvenLineLoopNotLastByte_X8B:
 	lsl.l	%d5,%d0	
 	rol.l	%d5,%d6
 	and.l	%d6,(%a3)
 	or.l	%d0,(%a3)
 	addq.l	#2,%a3
	dbf	%d4,_EvenLineLoop_X8B

	lea	30(%a0),%a0
	dbf	%d2,_EvenLoop_X8B

	movem.l	(%sp)+,%d5-%d6/%a2-%a4
	move.w	(%sp)+,%d4
	move.w	(%sp)+,%d3
		
	rts

_OddLoop_X8B:
 	movea.l	%a0,%a3
	move.w	%d3,%d4
	movea.l	%a2,%a4

_OddLineLoop_X8B:
	moveq.l	#0,%d0
	moveq.l	#-1,%d6
	
	move.b	(%a1)+,%d0
	move.b	(%a4)+,%d6
		
	dbf	%d4,_OddLineLoopNotLastByte_X8B

	lsl.l	%d1,%d0
	rol.l	%d1,%d6
	
	and.l	%d6,(%a3)
	or.l	%d0,(%a3)
	
	lea	30(%a0),%a0
	dbf	%d2,_EvenLoop_X8B	

	movem.l	(%sp)+,%d5-%d6/%a2-%a4
	move.w	(%sp)+,%d4
	move.w	(%sp)+,%d3
		
	rts
	
_OddLineLoopNotLastByte_X8B:

	lsl.w	#8,%d0
	rol.w	#8,%d6
	
	move.b	(%a4)+,%d6
	move.b	(%a1)+,%d0
	
 	lsl.l	%d5,%d0	
 	rol.l	%d5,%d6
 	
 	and.l	%d6,(%a3)
 	or.l	%d0,(%a3)
 	
 	addq.l	#2,%a3
	dbf	%d4,_OddLineLoop_X8B
	
	lea	30(%a0),%a0
	dbf	%d2,_OddLoop_X8B

	movem.l	(%sp)+,%d5-%d6/%a2-%a4
	move.w	(%sp)+,%d4
	move.w	(%sp)+,%d3
	
	rts
